import z from 'zod';
import { d as defineEventHandler, u as useLogger, g as getRouterParam, r as readValidatedBody, A as Announcement } from '../../../nitro/nitro.mjs';
import { r as requireAdminSession } from '../../../_/session.mjs';
import 'luxon';
import '@sequelize/core';
import 'html-to-text';
import 'crypto';
import 'node:fs';
import 'sharp';
import 'path';
import 'node:stream';
import 'jsdom';
import 'dompurify';
import 'mime-types';
import 'fs';
import 'fs/promises';
import 'linkify-html';
import '@peertube/http-signature';
import 'jsonld';
import 'lodash.intersection';
import 'email-templates';
import 'node:http';
import 'node:https';
import 'node:crypto';
import 'node:events';
import 'node:buffer';
import 'node:path';
import 'vue';
import 'vue-router';
import 'dotenv';
import 'url';
import 'bcryptjs';
import 'slugify';
import 'umzug';
import 'consola';
import '@sequelize/core/decorators-legacy';
import 'util';
import 'mitt';
import 'ical.js';
import 'node:url';
import 'fast-xml-parser';
import '../../../_/getUser.mjs';
import '../../../_/jwt.mjs';
import 'jose';

const schema = z.object({
  title: z.string().min(1).max(100),
  announcement: z.string().min(1),
  visible: z.boolean().optional()
});
const _id__put = defineEventHandler(async (event) => {
  await requireAdminSession(event);
  const log = useLogger("announcement put");
  const id = getRouterParam(event, "id");
  const body = await readValidatedBody(event, schema.parse);
  const announcement = await Announcement.findByPk(id);
  if (!announcement) {
    log.warn(`Not found: ${id}`);
    throw createError({ statusCode: 404, message: "Announcement not found" });
  }
  return announcement.update(body);
});

export { _id__put as default };
